/**
 * Pascal-2001 Language<BR>
 * ICS 142<BR>
 * Justin Erenkrantz<BR>
 * 10/13/2000<BR>
 * 
 * This class will define all primatives regarding Pascal-2001.
 */
public class PascalLanguage
{
   /* Used internally by the scanner */
   public static final short SCAN_INVALID = -1;
   public static final short SCAN_DIGIT = 0;
   public static final short SCAN_LETTER = 1;
   public static final short SCAN_SPECIAL = 2;

   /* Type of data stored within the symbol - Used by PascalType */
   public static final int TYPE_INVALID = -1;
   public static final int TYPE_INTEGER = 0;
   public static final int TYPE_ARRAY = 1;
   public static final int TYPE_RECORD = 2;
   public static final int TYPE_CONST = 3;
   public static final int TYPE_BOOLEAN = 4;

   /* Kind of data stored - Used by PascalSymbol */
   public static final int KIND_INVALID = -1;
   public static final int KIND_CONST = 0;
   public static final int KIND_VAR = 1;
   public static final int KIND_TYPE = 2;
   public static final int KIND_PROC = 3;
   public static final int KIND_LINK = 4;
   public static final int KIND_HUGECONST = 5;

   /* Language tokens */
   public static final int TOKEN_INVALID = -1;
   public static final int TOKEN_READ = 0;
   public static final int TOKEN_WRITE = 1;
   public static final int TOKEN_WRITELN = 2;
   public static final int TOKEN_DIV = 3;
   public static final int TOKEN_MOD = 4;
   public static final int TOKEN_IF = 5;
   public static final int TOKEN_THEN = 6;
   public static final int TOKEN_ELSE = 7;
   public static final int TOKEN_END = 8;
   public static final int TOKEN_WHILE = 9;
   public static final int TOKEN_DO = 10;
   public static final int TOKEN_ARRAY = 11;
   public static final int TOKEN_OF = 12;
   public static final int TOKEN_CONST = 13;
   public static final int TOKEN_TYPE = 14;
   public static final int TOKEN_VAR = 15;
   public static final int TOKEN_PROGRAM = 16;
   public static final int TOKEN_BEGIN = 17;
   public static final int TOKEN_LT = 18;
   public static final int TOKEN_GT = 19;
   public static final int TOKEN_COLON = 20;
   public static final int TOKEN_LP = 21;
   public static final int TOKEN_RP = 22;
   public static final int TOKEN_LB = 23;
   public static final int TOKEN_RB = 24;
   public static final int TOKEN_STAR = 25;
   public static final int TOKEN_PLUS = 26;
   public static final int TOKEN_MINUS = 27;
   public static final int TOKEN_ASSIGN = 28;
   public static final int TOKEN_EQUALS = 29;
   public static final int TOKEN_NE = 30;
   public static final int TOKEN_LTE = 31;
   public static final int TOKEN_GTE = 32;
   public static final int TOKEN_SEMICOLON = 33;
   public static final int TOKEN_COMMA = 34;
   public static final int TOKEN_PERIOD = 35;
   public static final int TOKEN_NUMBER = 36;
   public static final int TOKEN_IDENT = 37;
   public static final int TOKEN_COMMENT1_BEGIN = 38;
   public static final int TOKEN_COMMENT1_END = 39;
   public static final int TOKEN_COMMENT2_BEGIN = 40;
   public static final int TOKEN_COMMENT2_END = 41;
   public static final int TOKEN_ELSIF = 42;
   public static final int TOKEN_AND = 43;
   public static final int TOKEN_OR = 44;
   public static final int TOKEN_NOT = 45;
   public static final int TOKEN_RECORD = 46;
   public static final int TOKEN_PROCEDURE = 47;

   public static final String[] keywords = {
      "READ", "WRITE", "WRITELN", "DIV", "MOD",
      "IF", "THEN", "ELSE", "END", "WHILE",
      "DO", "ARRAY", "OF", "CONST", "TYPE",
      "VAR", "PROGRAM", "BEGIN", "<", ">",
      ":", "(", ")", "[", "]",
       "*", "+", "-", ":=", "=",
      "<>", "<=", ">=", ";", ",",
      "." , "number", "ident", 
      "(*", "*)", "{", "}",
      "ELSIF", "AND", "OR", "NOT",
      "RECORD", "PROCEDURE" };

   public static final int[] reservedWords = { 
      TOKEN_READ,    TOKEN_WRITE,   TOKEN_WRITELN, 
      TOKEN_DIV,     TOKEN_MOD,     TOKEN_IF,
      TOKEN_THEN,    TOKEN_ELSE,    TOKEN_END, 
      TOKEN_WHILE,   TOKEN_DO,      TOKEN_ARRAY,
      TOKEN_OF,      TOKEN_CONST,   TOKEN_TYPE,
      TOKEN_VAR,     TOKEN_PROGRAM, TOKEN_BEGIN, 
      TOKEN_ELSIF,   TOKEN_AND,     TOKEN_OR, 
      TOKEN_NOT,     TOKEN_RECORD,  TOKEN_PROCEDURE };

   public static final int[] terminalOps = { 
      TOKEN_COMMENT1_BEGIN,   TOKEN_COMMENT1_END, 
      TOKEN_COMMENT2_BEGIN,   TOKEN_COMMENT2_END, 
      TOKEN_RP,      TOKEN_LB,         TOKEN_RB,
      TOKEN_PLUS,    TOKEN_MINUS,      TOKEN_ASSIGN, 
      TOKEN_EQUALS,  TOKEN_NE,         TOKEN_LTE, 
      TOKEN_GTE,     TOKEN_SEMICOLON,  TOKEN_COMMA, 
      TOKEN_PERIOD };

   public static final int[] nonTerminalOps = { 
      TOKEN_LP,      TOKEN_STAR,       TOKEN_LT, 
      TOKEN_GT,      TOKEN_COLON };

}
