import java.io.*;
import java.text.*;
import java.util.*;

/**
 * Pascal-2001 Utility Class<BR>
 * ICS 142<BR>
 * Justin Erenkrantz<BR>
 * 11/26/2000<BR>
 * 
 * This class has various utility functions used by the various
 * components of the Pascal-2001 suite.
 *
 */
public class PascalUtils
{
	static List setArray(int[] keys, Object[] values)
	{
		Vector v = new Vector(values.length);
		
		for (int i = 0; i < keys.length; i++)
			v.add(values[keys[i]]);
		
		return v;
	}

	static StringBuffer readFile(String fileName)
	{
		if (fileName == null || fileName.length() <= 0)
			return null;

		FileReader fr = null;

		try
		{
			fr = new FileReader(fileName);
		}
		catch (FileNotFoundException fnfe)
		{	
			fnfe.printStackTrace();	
			System.out.println(fileName + "not found");
			return null;
		}

		BufferedReader br = new BufferedReader(fr);	
		String currentLine = null;

		try {
			StringBuffer sb = new StringBuffer();	

			while ((currentLine = br.readLine()) != null)
				sb.append(currentLine + " ");
			
			return sb;
		}
		catch (IOException ie)
		{	ie.printStackTrace();	}

		return null;
	}

	static void writeFile(String fileName, StringBuffer outputBuffer)
	{
		try
		{	
			FileWriter fos = new FileWriter(fileName);
			fos.write(outputBuffer.toString());
			fos.close();
		}
		catch (IOException ie)
		{	
			ie.printStackTrace();
			System.out.println("Error writing to " + fileName);
		}
	}

	static void writeInts(String fileName, int[] outputArray, int outputLength)
	{
		if (outputLength > outputArray.length)
			throw new ArrayIndexOutOfBoundsException();

		try
		{	
			// no appending
			FileOutputStream fos = new FileOutputStream(fileName);
			ObjectOutputStream oos = new ObjectOutputStream(fos);

			for (int i = 0; i < outputLength; i++)
				oos.writeInt(outputArray[i]);

			oos.close();
			fos.close();
		}
		catch (IOException ie)
		{	
			ie.printStackTrace();
			System.out.println("Error writing to " + fileName);
		}
	}

	public static int[] loadInt(String fileName, int maxSize)
	{
		int[] tmp = new int[maxSize];
		int returnCount = 0;

		FileInputStream fis = null;
		ObjectInputStream ois = null;

		try
		{	
			// no appending
			fis = new FileInputStream(fileName);
			ois = new ObjectInputStream(fis);

			while(true)
				tmp[returnCount++] = ois.readInt();
			/*do
			{
				tmp[returnCount++] = ois.readInt();
			}
			while (tmp[returnCount - 1] != 0);
			*/
		}
		catch (EOFException ee)
		{	
			try
			{
				if (ois != null)
					ois.close();

				if (fis != null)
					fis.close();
			}
			catch (IOException ie)
			{}
		}
		catch (IOException ie)
		{	
			ie.printStackTrace();
			System.out.println("Error writing to " + fileName);
		}

		if (returnCount == 0)
			return null;

		int[] returnValue = new int[--returnCount];
		System.arraycopy(tmp, 0, returnValue, 0, returnCount);
		return returnValue;
	}
}
