import java.io.Writer;
import java.io.FileWriter;
import java.io.StringWriter;
import java.io.BufferedWriter;
import java.io.IOException;

public class PascalWriter
{
   private BufferedWriter bw = null;
   private Writer w = null;
   private String lineSep = null;

   PascalWriter()
   {
      loadFile(null);
   }

   PascalWriter(String filename)
   {
      loadFile(filename);
   }
   
   public void loadFile(String filename)
   {
      if (filename != null)
      {
         try
         {  w = new FileWriter(filename); }
         catch (IOException ie)
         {
            // FIXME: this might not be the best of ideas.
            System.err.println("Error writing to file.");
            System.err.println("Trying to continue on.");
            ie.printStackTrace();
            w = new StringWriter();
         }
      }
      else
         w = new StringWriter();

      bw = new BufferedWriter(w);
   }

   public void close()
   {
      flush();

      if (w instanceof StringWriter)
         System.out.println(w);
     
      try
      { bw.close(); }
      catch (IOException ie)
      {  ie.printStackTrace();   }
      
      try
      { w.close(); }
      catch (IOException ie)
      {  ie.printStackTrace();   }
   }

   public void flush()
   {
      try
      { bw.flush(); }
      catch (IOException ie)
      {  ie.printStackTrace();   }
   }

   public void write(String s)
   {
      try
      { bw.write(s); }
      catch (IOException ie)
      {  ie.printStackTrace();   }
   }

   public void write(int i)
   {
      try
      { bw.write(i); }
      catch (IOException ie)
      {  ie.printStackTrace();   }
   }

   public void writeln(String s)
   {
      write(s);
      if (lineSep == null)
         lineSep = System.getProperty("line.separator");
      write(lineSep);
   }
}
